--!parent
--!encoding=utf-8

--****************************************************************************
-- @file      Tree Sort Demo - main class
-- @author    Valentin Schmidt
-- @version   0.2
--****************************************************************************

global $

property pAppName

-- WIDGETS
property pMainWindow
property pTreeWidget
property pRootItem

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

	me.pAppName = "TreeSort"

	-- CREATE MAIN WINDOW
	me.pMainWindow = $.Qt.MainWindow.new()
	me.pMainWindow.connect($.Qt.Event.Close, me, #slotQuit)
	me.pMainWindow.setWindowTitle(me.pAppName)
	me.pMainWindow.setToolButtonStyle($.Qt.ToolButtonFollowStyle)
	
	-- CREATE TREE
	me.pTreeWidget = $.Qt.TreeWidget.new(me.pMainWindow)
	me.pMainWindow.setCentralWidget(me.pTreeWidget)

	me.pTreeWidget.setColumnCount(4)
	me.pTreeWidget.setHeaderLabels(["Strings","Integers","Dates","Filesizes"])
	me.pTreeWidget.setSortingEnabled(1)
	me.pTreeWidget.setDragDropMode($.Qt.QAbstractItemView.DragDrop) -- was: InternalMove
	

	-- ADD  ITEMS
  me.pRootItem = $.Qt.TreeWidgetItem.new(me.pTreeWidget)
 	me.pRootItem.setText(0, "Root")
  me.pTreeWidget.addTopLevelItem(me.pRootItem)
  
  data = [100,12,22]
  dates = [date(2012), the systemDate, date(2018)]
  repeat with i = 1 to 3
		childItem = $.Qt.TreeWidgetItem.new(me.pRootItem)
		childItem.setText(0, string(data[i])) -- add as strings
		childItem.setData(1, $.Qt.EditRole, data[i]) -- add as integers
		childItem.setData(2, $.Qt.EditRole, dates[i]) -- add as dates
		childItem.setText(3, data[i]&" KB") -- show filesize as string
		childItem.setSortValue(3, data[i]) -- use hidden numeric value for sorting
		childItem.setFlags(bitOr(childItem.flags(),$.Qt.ItemIsEditable))
		me.pRootItem.addChild(childItem)
  end repeat
  
	me.pMainWindow.show()

	return me
end

--------------------------------------
-- @callback
--------------------------------------
on slotQuit (me)
	halt()
end
