--!parent
--!encoding=utf-8

--****************************************************************************
-- @package   Qt OOP API
-- @version  	0.2
-- @requires  Xtra("QtWidgets")
-- @author   	Valentin Schmidt
--****************************************************************************

global $

property ancestor
property _id
property _class

----------------------------------------
-- @constructor
----------------------------------------
on new (me)
  me._class = #NetworkReply
  -- implement interface
  me.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
  return me
end

-- static
on _make (scr, id)
	obj = scr.rawNew()
	obj.ancestor = $.include($.Qt.libDir&"classes/iObject.ls").new()
	obj._class = #NetworkReply
	obj._id = id
	return obj
end

----------------------------------------
-- ACTIONS
----------------------------------------

-- abort ()
on abort (me)
  $.Qt._qx.callObject(me._id,#abort)
end

-- close ()
on close (me)
  $.Qt._qx.callObject(me._id,#close)
end

-- objectName () -> string
on objectName (me)
  return $.Qt._qx.callObject(me._id,#objectName)
end

-- readAll () -> bytearray|string
on readAll (me)
  return $.Qt._qx.callObject(me._id,#readAll)
end

-- setObjectName (string)
on setObjectName (me,p1)
  $.Qt._qx.callObject(me._id,#setObjectName,p1)
end

----------------------------------------
-- STATIC
----------------------------------------

----------------------------------------
-- SIGNALS
----------------------------------------

-- error -> int
on error(me,id,p1)
  me._detach(#error,id,p1)
end

-- downloadProgress -> int,int
on downloadProgress(me,id,p1,p2)
  me._detach(#downloadProgress,id,p1,p2)
  
	-- test
	--obj = $.Qt.NetworkReply._make(id)
	--me._detach(#downloadProgress,obj,p1,p2)
end

-- finished
on finished(me,id)
	me._detach(#finished,id)
	
	-- test
	--obj = $.Qt.NetworkReply._make(id)
	--me._detach(#finished,obj)
end

-- uploadProgress -> int,int
on uploadProgress(me,id,p1,p2)
  me._detach(#uploadProgress,id,p1,p2)
end

