--!parent

--****************************************************************************
-- @file			LSW CORE LIB: QTWIDGETS - QT-CONSTANTS EXTENSION
-- @author   	Valentin Schmidt
-- @version  	0.2
-- @desc      Adds predefined constants to Qt namespace (e.g. $.Qt.AlignLeft)
-- @todo
--****************************************************************************

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

	-- see http://doc.qt.io/qt-4.8/qt.html

	----------------------------------------
	-- enum Qt::AlignmentFlag
	----------------------------------------
	me[#AlignLeft] = 1
	me[#AlignRight] = 2
	me[#AlignHCenter] = 4
	me[#AlignJustify] = 8
	me[#AlignAbsolute] = 16

	me[#AlignTop] = 32
	me[#AlignBottom] = 64
	me[#AlignVCenter] = 128

	-- enum 	AnchorAttribute { AnchorName, AnchorHref }
	-- enum 	AnchorPoint { AnchorLeft, AnchorHorizontalCenter, AnchorRight, AnchorTop, AnchorVerticalCenter, AnchorBottom }
	-- enum 	ApplicationAttribute { AA_ImmediateWidgetCreation, AA_MSWindowsUseDirect3DByDefault, AA_DontShowIconsInMenus, AA_NativeWindows, ..., AA_CaptureMultimediaKeys }
	-- enum 	ArrowType { NoArrow, UpArrow, DownArrow, LeftArrow, RightArrow }
	-- enum 	AspectRatioMode { IgnoreAspectRatio, KeepAspectRatio, KeepAspectRatioByExpanding }
	-- enum 	Axis { XAxis, YAxis, ZAxis }
	-- enum 	BGMode { TransparentMode, OpaqueMode }
	-- enum 	BrushStyle { NoBrush, SolidPattern, Dense1Pattern, Dense2Pattern, ..., TexturePattern }
	-- enum 	CaseSensitivity { CaseInsensitive, CaseSensitive }
	-- enum 	CheckState { Unchecked, PartiallyChecked, Checked }
	-- enum 	ClipOperation { NoClip, ReplaceClip, IntersectClip, UniteClip }
	-- enum 	ConnectionType { AutoConnection, DirectConnection, QueuedConnection, BlockingQueuedConnection, UniqueConnection, AutoCompatConnection }

	----------------------------------------
	-- enum Qt::ContextMenuPolicy
	----------------------------------------
	me[#NoContextMenu] = 0 -- the widget does not feature a context menu, context menu handling is deferred to the widget's parent.
	me[#PreventContextMenu] = 4 -- the widget does not feature a context menu, and in contrast to NoContextMenu, the handling is not deferred to the widget's parent. This means that all right mouse button events are guaranteed to be delivered to the widget itself through mousePressEvent(), and mouseReleaseEvent().
	me[#DefaultContextMenu] = 1 -- the widget's QWidget::contextMenuEvent() handler is called.
	me[#ActionsContextMenu] = 2 -- the widget displays its QWidget::actions() as context menu.
	me[#CustomContextMenu] = 3 -- the widget emits the QWidget::customContextMenuRequested() signal.

	-- enum 	CoordinateSystem { DeviceCoordinates, LogicalCoordinates }
	-- enum 	Corner { TopLeftCorner, TopRightCorner, BottomLeftCorner, BottomRightCorner }
	-- enum 	CursorMoveStyle { LogicalMoveStyle, VisualMoveStyle }
	
	----------------------------------------
	-- enum Qt::CursorShape
	----------------------------------------
	me[#ArrowCursor] = 0
	me[#UpArrowCursor] = 1
	me[#CrossCursor] = 2
	me[#WaitCursor] = 3
	me[#IBeamCursor] = 4
	me[#SizeVerCursor] = 5
	me[#SizeHorCursor] = 6
	me[#SizeBDiagCursor] = 7
	me[#SizeFDiagCursor] = 8
	me[#SizeAllCursor] = 9
	me[#BlankCursor] = 10
	me[#SplitVCursor] = 11
	me[#SplitHCursor] = 12
	me[#PointingHandCursor] = 13
	me[#ForbiddenCursor] = 14
	me[#OpenHandCursor] = 17
	me[#ClosedHandCursor] = 18
	me[#WhatsThisCursor] = 15
	me[#BusyCursor] = 16
	me[#DragMoveCursor] = 20
	me[#DragCopyCursor] = 19
	me[#DragLinkCursor] = 21
	me[#BitmapCursor] = 24
	
	-- enum 	DateFormat { TextDate, ISODate, SystemLocaleShortDate, SystemLocaleLongDate, ..., LocalDate }
	-- enum 	DayOfWeek { Monday, Tuesday, Wednesday, Thursday, ..., Sunday }
	
	-- enum 	DockWidgetArea { LeftDockWidgetArea, RightDockWidgetArea, TopDockWidgetArea, BottomDockWidgetArea, AllDockWidgetAreas, NoDockWidgetArea }
	----------------------------------------
	-- enum Qt::DockWidgetArea
	----------------------------------------
	me[#LeftDockWidgetArea] = 0
	me[#RightDockWidgetArea] = 1
	me[#TopDockWidgetArea] = 4
	me[#BottomDockWidgetArea] = 8
	--me[#AllDockWidgetAreas] = 4
	me[#NoDockWidgetArea] = 0
	
	----------------------------------------
	-- enum Qt::DropAction
	----------------------------------------
	me[#CopyAction] = 1	-- Copy the data to the target.
	me[#MoveAction] = 2	-- Move the data from the source to the target.
	me[#LinkAction] = 4	-- Create a link from the source to the target.
	me[#ActionMask] = 255	 
	me[#IgnoreAction] = 0	-- Ignore the action (do nothing with the data).
	me[#TargetMoveAction] = 32770
	
	-- enum 	EventPriority { HighEventPriority, NormalEventPriority, LowEventPriority }
	-- enum 	FillRule { OddEvenFill, WindingFill }
	-- enum 	FocusPolicy { TabFocus, ClickFocus, StrongFocus, WheelFocus, NoFocus }
	
	----------------------------------------
	-- enum Qt::FocusReason
	----------------------------------------
	me[#MouseFocusReason] = 0
	me[#TabFocusReason] = 1
	me[#BacktabFocusReason] = 2
	me[#ActiveWindowFocusReason] = 3
	me[#PopupFocusReason] = 4
	me[#ShortcutFocusReason] = 5
	me[#MenuBarFocusReason	] = 6
	me[#OtherFocusReason] = 7
	
	-- enum 	GestureFlag { DontStartGestureOnChildren, ReceivePartialGestures, IgnoredGesturesPropagateToParent }
	-- enum 	GestureState { GestureStarted, GestureUpdated, GestureFinished, GestureCanceled }
	-- enum 	GestureType { TapGesture, TapAndHoldGesture, PanGesture, PinchGesture, SwipeGesture, CustomGesture }

	----------------------------------------
	-- enum Qt::GlobalColor
	----------------------------------------
	me[#white] = rgb("ffffff")
	me[#black] = rgb("000000")
	me[#red] = rgb("ff0000")
	me[#darkRed] = rgb("800000")
	me[#green] = rgb("00ff00")
	me[#darkGreen] = rgb("008000")
	me[#blue] = rgb("0000ff")
	me[#darkBlue] = rgb("000080")
	me[#cyan] = rgb("00ffff")
	me[#darkCyan] = rgb("008080")
	me[#magenta] = rgb("ff00ff")
	me[#darkMagenta] = rgb("800080")
	me[#yellow] = rgb("ffff00")
	me[#darkYellow] = rgb("808000")
	me[#gray] = rgb("a0a0a4")
	me[#darkGray] = rgb("808080")
	me[#lightGray] = rgb("c0c0c0")

	-- enum 	HitTestAccuracy { ExactHit, FuzzyHit }
	-- enum 	ImageConversionFlag { AutoColor, ColorOnly, MonoOnly, DiffuseDither, ..., NoOpaqueDetection }
	-- enum 	InputMethodHint { ImhNone, ImhHiddenText, ImhNoAutoUppercase, ImhPreferNumbers, ..., ImhExclusiveInputMask }
	-- enum 	InputMethodQuery { ImMicroFocus, ImFont, ImCursorPosition, ImSurroundingText, ..., ImAnchorPosition }

	----------------------------------------
	-- enum Qt::ItemDataRole
	----------------------------------------
	me[#DisplayRole] = 0 -- The key data to be rendered in the form of text. (QString)
	me[#DecorationRole] = 1 -- The data to be rendered as a decoration in the form of an icon. (QColor, QIcon or QPixmap)
	me[#EditRole] = 2 -- The data in a form suitable for editing in an editor. (QString)
	me[#ToolTipRole] = 3 -- The data displayed in the item's tooltip. (QString)
	me[#StatusTipRole] = 4 -- The data displayed in the status bar. (QString)
	me[#WhatsThisRole] = 5 -- The data displayed for the item in "What's This?" mode. (QString)
	me[#SizeHintRole] = 13 -- The size hint for the item that will be supplied to views. (QSize)
	-- ...
	me[#UserRole] = 32 -- The first role that can be used for application-specific purposes.

	-- enum 	ItemFlag { NoItemFlags, ItemIsSelectable, ItemIsEditable, ItemIsDragEnabled, ..., ItemIsTristate }

	----------------------------------------
	-- flags Qt::ItemFlags
	----------------------------------------
	me[#NoItemFlags] = 0 -- It does not have any properties set.
	me[#ItemIsSelectable] = 1 -- It can be selected.
	me[#ItemIsEditable] = 2 -- It can be edited.
	me[#ItemIsDragEnabled] = 4 -- It can be dragged.
	me[#ItemIsDropEnabled] = 8 -- It can be used as a drop target.
	me[#ItemIsUserCheckable] = 16 -- It can be checked or unchecked by the user.
	me[#ItemIsEnabled] = 32 -- The user can interact with the item.
	me[#ItemIsTristate] = 64 -- The item is checkable with three separate states.

	-- enum 	ItemSelectionMode { ContainsItemShape, IntersectsItemShape, ContainsItemBoundingRect, IntersectsItemBoundingRect }
	-- enum 	Key { Key_Escape, Key_Tab, Key_Backtab, Key_Backspace, ..., Key_Cancel }

	----------------------------------------
	-- enum Qt::KeyboardModifier
	----------------------------------------
	me[#NoModifier] = 0 --	No modifier key is pressed.
	me[#ShiftModifier] = 33554432 --	A Shift key on the keyboard is pressed.
	me[#ControlModifier] = 67108864 --	A Ctrl key on the keyboard is pressed.
	me[#AltModifier] = 134217728 --	An Alt key on the keyboard is pressed.
	me[#MetaModifier] = 268435456 --	A Meta key on the keyboard is pressed.
	me[#KeypadModifier] = 536870912 --	A keypad button is pressed.

	-- enum 	LayoutDirection { LeftToRight, RightToLeft, LayoutDirectionAuto }
	-- enum 	MaskMode { MaskInColor, MaskOutColor }
	-- enum 	MatchFlag { MatchExactly, MatchFixedString, MatchContains, MatchStartsWith, ..., MatchRecursive }

	----------------------------------------
	-- enum Qt::Modifier
	----------------------------------------
	me[#SHIFT] = me.ShiftModifier --	The Shift keys provided on all standard keyboards.
	me[#META] = me.MetaModifier --	The Meta keys.
	me[#CTRL] = me.ControlModifier --	The Ctrl keys.
	me[#ALT] = me.AltModifier --	The normal Alt keys, but not keys like AltGr.
	me[#UNICODE_ACCEL] = 0 --	The shortcut is specified as a Unicode code point, not as a Qt Key.

	-- enum 	MouseButton { NoButton, LeftButton, RightButton, MidButton, ..., XButton2 }
	-- enum 	NavigationMode { NavigationModeNone, NavigationModeKeypadTabOrder, NavigationModeKeypadDirectional, NavigationModeCursorAuto, NavigationModeCursorForceVisible }
	
	----------------------------------------
	-- enum Qt::Orientation
	----------------------------------------
	me[#Horizontal] = 1
	me[#Vertical] = 2
	
	-- enum 	PenCapStyle { FlatCap, SquareCap, RoundCap }
	-- enum 	PenJoinStyle { MiterJoin, BevelJoin, RoundJoin, SvgMiterJoin }
	-- enum 	PenStyle { NoPen, SolidLine, DashLine, DotLine, ..., CustomDashLine }
	-- enum 	ScrollBarPolicy { ScrollBarAsNeeded, ScrollBarAlwaysOff, ScrollBarAlwaysOn }
	-- enum 	ShortcutContext { WidgetShortcut, WidgetWithChildrenShortcut, WindowShortcut, ApplicationShortcut }
	-- enum 	SizeHint { MinimumSize, PreferredSize, MaximumSize, MinimumDescent }
	-- enum 	SizeMode { AbsoluteSize, RelativeSize }
	-- enum 	SortOrder { AscendingOrder, DescendingOrder }
	-- enum 	TextElideMode { ElideLeft, ElideRight, ElideMiddle, ElideNone }
	-- enum 	TextFlag { TextSingleLine, TextDontClip, TextExpandTabs, TextShowMnemonic, ..., TextJustificationForced }
	-- enum 	TextFormat { PlainText, RichText, AutoText, LogText }
	-- enum 	TextInteractionFlag { NoTextInteraction, TextSelectableByMouse, TextSelectableByKeyboard, LinksAccessibleByMouse, ..., TextBrowserInteraction }
	-- enum 	TileRule { StretchTile, RepeatTile, RoundTile }
	-- enum 	TimeSpec { LocalTime, UTC, OffsetFromUTC }

	----------------------------------------
	-- enum Qt::ToolBarArea
	----------------------------------------
	me[#LeftToolBarArea] = 1
	me[#RightToolBarArea] = 2
	me[#TopToolBarArea] = 4
	me[#BottomToolBarArea] = 8
	me[#NoToolBarArea] = 0

	----------------------------------------
	-- enum Qt::ToolButtonStyle
	----------------------------------------
	me[#ToolButtonIconOnly] = 0 --	Only display the icon.
	me[#ToolButtonTextOnly] = 1 --	Only display the text.
	me[#ToolButtonTextBesideIcon] = 2 --	The text appears beside the icon.
	me[#ToolButtonTextUnderIcon] = 3 --	The text appears under the icon.
	me[#ToolButtonFollowStyle] = 4 --	Follow the style.

	-- enum 	TouchPointState { TouchPointPressed, TouchPointMoved, TouchPointStationary, TouchPointReleased }
	-- enum 	TransformationMode { FastTransformation, SmoothTransformation }
	-- enum 	UIEffect { UI_AnimateMenu, UI_FadeMenu, UI_AnimateCombo, UI_AnimateTooltip, UI_FadeTooltip, UI_AnimateToolBox }
	-- enum 	WhiteSpaceMode { WhiteSpaceNormal, WhiteSpacePre, WhiteSpaceNoWrap }
	-- enum 	WidgetAttribute { WA_AcceptDrops, WA_AlwaysShowToolTips, WA_ContentsPropagated, WA_CustomWhatsThis, ..., WA_MacNoShadow }

	----------------------------------------
	-- enum Qt::WindowFlags
	----------------------------------------
	--me[#Widget] = 0
	me[#Window] = 1
	me[#Dialog] = 2
	me[#Sheet] = 4
	me[#Drawer] = 6
	me[#Popup] = 8
	me[#Tool] = 10
	-- Mac OS X
	me[#ToolTip] = 12
	me[#SplashScreen] = 14
	me[#Desktop] = 16
	me[#SubWindow] = 18
	-- customize top-level windows only
	me[#MSWindowsFixedSizeDialogHint] = 256
	me[#MSWindowsOwnDC] = 512
	me[#X11BypassWindowManagerHint] = 1024
	me[#FramelessWindowHint] = 2048

	----------------------------------------
	-- enum Qt::WindowFrameSection { NoSection, LeftSection, TopLeftSection, TopSection, ..., TitleBarArea }
	----------------------------------------
	
	----------------------------------------
	-- enum Qt::WindowModality
	----------------------------------------
	me[#NonModal] = 0
	me[#WindowModal] = 1
	me[#ApplicationModal] = 2
	
	----------------------------------------
	-- enum Qt::QWindowState
	----------------------------------------
	me[#WindowNoState] = 0 -- The window has no state set (in normal state).
	me[#WindowMinimized] = 1 -- The window is minimized (i.e. iconified).
	me[#WindowMaximized] = 2 -- The window is maximized with a frame around it.
	me[#WindowFullScreen] = 4 -- The window fills the entire screen without any frame around it.
	me[#WindowActive] = 8 -- The window is the active window, i.e. it has keyboard focus.

	-- enum WindowType { Widget, Window, Dialog, Sheet, ..., WMacNoSheet }


 	--**************************************
 	-- OTHER NAMESPACES
 	--**************************************

	----------------------------------------
	-- enum QAbstractItemView::DragDropMode
	----------------------------------------^
	p = [:]

	p[#NoDragDrop] = 0
	p[#DragOnly] = 1
	p[#DropOnly] = 2
	p[#DragDrop] = 3
	p[#InternalMove] = 4

	me[#QAbstractItemView] = p

	----------------------------------------
	-- enum QDialog::DialogCode
	----------------------------------------
	p = [:]

	p[#Accepted] = 1
	p[#Rejected] = 0

	me[#QDialog] = p


	----------------------------------------
	-- enum QDir::Filter
	----------------------------------------
	p = [:]
	
	p[#Dirs] = 1 -- List directories that match the filters.
	p[#AllDirs] = 1024 -- List all directories; i.e. don't apply the filters to directory names.
	p[#Files] = 2 -- List files.
	p[#Drives] = 4 -- List disk drives (ignored under Unix).
	p[#NoSymLinks] = 8 -- Do not list symbolic links (ignored by operating systems that don't support symbolic links).
	p[#NoDotAndDotDot] = 4096 -- Do not list the special entries "." and "..".
	p[#NoDot] = 8192 -- Do not list the special entry ".".
	p[#NoDotDot] = 16384 -- Do not list the special entry "..".
	--p[#AllEntries] = Dirs | Files | Drives -- List directories, files, drives and symlinks (this does not list broken symlinks unless you specify System).
	p[#Readable] = 16 -- List files for which the application has read access. The Readable value needs to be combined with Dirs or Files.
	p[#Writable] = 32 -- List files for which the application has write access. The Writable value needs to be combined with Dirs or Files.
	p[#Executable] = 64 -- List files for which the application has execute access. The Executable value needs to be combined with Dirs or Files.
	p[#Modified] = 128 -- Only list files that have been modified (ignored on Unix).
	p[#Hidden] = 256 -- List hidden files (on Unix, files starting with a ".").
	p[#System] = 512 -- List system files (on Unix, FIFOs, sockets and device files are included; on Windows, .lnk files are included)
	p[#CaseSensitive] = 2048 -- The filter should be case sensitive.
 
	----------------------------------------
	-- enum QDir::SortFlag
	----------------------------------------
	p[#Name] = 0 -- Sort by name.
	p[#Time] = 1 -- Sort by time (modification time).
	p[#Size] = 2 -- Sort by file size.
	p[#Type] = 128 -- Sort by file type (extension).
	p[#Unsorted] = 3 -- Do not sort.
	p[#NoSort] = -1 -- Not sorted by default.
	p[#DirsFirst] = 4 -- Put the directories first, then the files.
	p[#DirsLast] = 32 -- Put the files first, then the directories.
	p[#Reversed] = 8 -- Reverse the sort order.
	p[#IgnoreCase] = 16 -- Sort case-insensitively.
	p[#LocaleAware] = 64 -- Sort items appropriately using the current locale settings.

	me[#QDir] = p

	----------------------------------------
	-- enum QDockWidget::DockWidgetFeature
	----------------------------------------
	p = [:]

	p[#DockWidgetClosable] = 1
	p[#DockWidgetMovable] = 2
	p[#DockWidgetFloatable] = 4
	p[#DockWidgetVerticalTitleBar] = 8

	me[#QDockWidget] = p

	----------------------------------------
	-- enum QFont::Weight
	----------------------------------------
	p = [:]

	p[#Light] = 25
	p[#Normal] = 50
	p[#DemiBold] = 63
	p[#Bold] = 75
	p[#Black] = 87

	me[#QFont] = p

	----------------------------------------
	-- enum QImage::Format
	----------------------------------------
	p = [:]
	
	-- ...
	p[#Format_RGB32] = 4
	p[#Format_ARGB32] = 5
	p[#Format_ARGB32_Premultiplied] = 6
	-- ...
	
	me[#QImage] = p
	
	----------------------------------------
	-- enum QKeySequence:StandardKey
	----------------------------------------
	p = [:]

	p[#AddTab] = 19 -- Add new tab.
	p[#Back] = 13 -- Navigate back.
	p[#Bold] = 27 -- Bold text.
	p[#Close] = 4 -- Close document/tab.
	p[#Copy] = 9 -- Copy.
	p[#Cut] = 8 -- Cut.
	p[#Delete] = 7 -- Delete.
	p[#DeleteEndOfLine] = 60 -- Delete end of line.
	p[#DeleteEndOfWord] = 59 -- Delete word from the end of the cursor.
	p[#DeleteStartOfWord] = 58 -- Delete the beginning of a word up to the cursor.
	p[#Find] = 22 -- Find in document.
	p[#FindNext] = 23 -- Find next result.
	p[#FindPrevious] = 24 -- Find previous result.
	p[#Forward] = 14 -- Navigate forward.
	p[#HelpContents] = 1 -- Open help contents.
	p[#InsertLineSeparator] = 62 -- Insert a new line.
	p[#InsertParagraphSeparator] = 61 -- Insert a new paragraph.
	p[#Italic] = 28 -- Italic text.
	p[#MoveToEndOfBlock] = 41 -- Move cursor to end of block. This shortcut is only used on the OS X.
	p[#MoveToEndOfDocument] = 43 -- Move cursor to end of document.
	p[#MoveToEndOfLine] = 39 -- Move cursor to end of line.
	p[#MoveToNextChar] = 30 -- Move cursor to next character.
	p[#MoveToNextLine] = 34 -- Move cursor to next line.
	p[#MoveToNextPage] = 36 -- Move cursor to next page.
	p[#MoveToNextWord] = 32 -- Move cursor to next word.
	p[#MoveToPreviousChar] = 31 -- Move cursor to previous character.
	p[#MoveToPreviousLine] = 35 -- Move cursor to previous line.
	p[#MoveToPreviousPage] = 37 -- Move cursor to previous page.
	p[#MoveToPreviousWord] = 33 -- Move cursor to previous word.
	p[#MoveToStartOfBlock] = 40 -- Move cursor to start of a block. This shortcut is only used on OS X.
	p[#MoveToStartOfDocument] = 42 -- Move cursor to start of document.
	p[#MoveToStartOfLine] = 38 -- Move cursor to start of line.
	p[#New] = 6 -- Create new document.
	p[#NextChild] = 20 -- Navigate to next tab or child window.
	p[#Open] = 3 -- Open document.
	p[#Paste] = 10 -- Paste.
	p[#Preferences] = 64 -- Open the preferences dialog.
	p[#PreviousChild] = 21 -- Navigate to previous tab or child window.
	p[#Print] = 18 -- Print document.
	p[#Quit] = 65 -- Quit the application.
	p[#Redo] = 12 -- Redo.
	p[#Refresh] = 15 -- Refresh or reload current document.
	p[#Replace] = 25 -- Find and replace.
	p[#SaveAs] = 63 -- Save document after prompting the user for a file name.
	p[#Save] = 5 -- Save document.
	p[#SelectAll] = 26 -- Select all text.
	p[#SelectEndOfBlock] = 55 -- Extend selection to the end of a text block. This shortcut is only used on OS X.
	p[#SelectEndOfDocument] = 57 -- Extend selection to end of document.
	p[#SelectEndOfLine] = 53 -- Extend selection to end of line.
	p[#SelectNextChar] = 44 -- Extend selection to next character.
	p[#SelectNextLine] = 48 -- Extend selection to next line.
	p[#SelectNextPage] = 50 -- Extend selection to next page.
	p[#SelectNextWord] = 46 -- Extend selection to next word.
	p[#SelectPreviousChar] = 45 -- Extend selection to previous character.
	p[#SelectPreviousLine] = 49 -- Extend selection to previous line.
	p[#SelectPreviousPage] = 51 -- Extend selection to previous page.
	p[#SelectPreviousWord] = 47 -- Extend selection to previous word.
	p[#SelectStartOfBlock] = 54 -- Extend selection to the start of a text block. This shortcut is only used on OS X.
	p[#SelectStartOfDocument] = 56 -- Extend selection to start of document.
	p[#SelectStartOfLine] = 52 -- Extend selection to start of line.
	p[#Underline] = 29 -- Underline text.
	p[#Undo] = 11 -- Undo.
	p[#UnknownKey] = 0 -- Unbound key.
	p[#WhatsThis] = 2 -- Activate whats this.
	p[#ZoomIn] = 16 -- Zoom in.
	p[#ZoomOut] = 17 -- Zoom out.

	me[#QKeySequence] = p

	----------------------------------------
	-- enum QLineEdit::EchoMode
	----------------------------------------
	p = [:]

	p[#Normal] = 0
	p[#NoEcho] = 1
	p[#Password] = 2
	p[#PasswordEchoOnEdit] = 3

	me[#QLineEdit] = p

	----------------------------------------
	-- enum QMessageBox::StandardButton
	----------------------------------------
	p = [:]

	p[#Ok] = 1024
	p[#Open] = 8192
	p[#Save] = 2048
	p[#Cancel] = 4194304
	p[#Close] = 2097152
	p[#Discard] = 8388608

	me[#QMessageBox] = p

	----------------------------------------
	-- enum QNetworkRequest::Attribute
	----------------------------------------
	p = [:]
	
  p[#HttpStatusCodeAttribute] = 0
  p[#HttpReasonPhraseAttribute] = 1
  p[#RedirectionTargetAttribute] = 2
  p[#ConnectionEncryptedAttribute] = 3
  p[#CacheLoadControlAttribute] = 4
  p[#CacheSaveControlAttribute] = 5
  p[#SourceIsFromCacheAttribute] = 6
  p[#DoNotBufferUploadDataAttribute] = 7
  p[#HttpPipeliningAllowedAttribute] = 8
  p[#HttpPipeliningWasUsedAttribute] = 9
  p[#CustomVerbAttribute] = 10
  p[#CookieLoadControlAttribute] = 11
  p[#CookieSaveControlAttribute] = 13
  p[#AuthenticationReuseAttribute] = 12
  p[#User] = 1000
  p[#UserMax] = 32767
  
	me[#QNetworkRequest] = p
	
	----------------------------------------
	-- enum QPrinter::OutputFormat
	----------------------------------------
	p = [:]

	p[#NativeFormat] = 0
	p[#PdfFormat] = 1
	p[#PostScriptFormat] = 2

	----------------------------------------
	-- enum QPrinter::PrinterMode
	----------------------------------------

	p[#ScreenResolution] = 0
	p[#PrinterResolution] = 1
	p[#HighResolution] = 2

	me[#QPrinter] = p

	----------------------------------------
	-- enum QsciScintilla::BraceMatch
	----------------------------------------
	p = [:]

	p[#NoBraceMatch] = 0
	p[#StrictBraceMatch] = 1
	p[#SloppyBraceMatch] = 2

	----------------------------------------
	-- enum QsciScintilla::FoldStyle
	----------------------------------------

	p[#NoFoldStyle] = 0
	p[#PlainFoldStyle] = 1
	p[#CircledFoldStyle] = 2
	p[#BoxedFoldStyle] = 3
	p[#CircledTreeFoldStyle] = 4
	p[#BoxedTreeFoldStyle] = 5

	me[#QsciScintilla] = p

	----------------------------------------
	-- enum QSettings::Format
	----------------------------------------
	p = [:]

	p[#NativeFormat] = 0
	p[#IniFormat] = 1

	me[#QSettings] = p

	----------------------------------------
	-- enum QSizePolicy::Policy
	----------------------------------------
	p = [:]

	p[#Fixed] = 0
	p[#GrowFlag] = 1
	p[#ExpandFlag] = 2
	p[#ShrinkFlag] = 4
	p[#IgnoreFlag] = 8

	me[#QSizePolicy] = p

	----------------------------------------
	-- enum QSystemTrayIcon::ActivationReason
	----------------------------------------
	p = [:]

	p[#Unknown] = 0
	p[#Context] = 1
	p[#DoubleClick] = 2
	p[#Trigger] = 4
	p[#MiddleClick] = 8

	me[#QSystemTrayIcon] = p
	
	----------------------------------------
	-- enum QTextListFormat::Style
	----------------------------------------
	p = [:]

	p[#ListDisc] = -1
	p[#ListCircle] = -2
	p[#ListSquare] = -3
	p[#ListDecimal] = -4
	p[#ListLowerAlpha] = -5
	p[#ListUpperAlpha] = -6
	p[#ListLowerRoman] = -7
	p[#ListUpperRoman] = -8

	me[#QTextListFormat] = p

	----------------------------------------
	-- enum QToolButton::ToolButtonPopupMode
	----------------------------------------
	p = [:]

	p[#DelayedPopup] = 0
	p[#MenuButtonPopup] = 1
	p[#InstantPopup] = 2
	
	me[#QToolButton] = p

	----------------------------------------
	-- enum QWebPage::LinkDelegationPolicy
	----------------------------------------
	p = [:]

	p[#DontDelegateLinks] = 0
	p[#DelegateExternalLinks] = 1
	p[#DelegateAllLinks] = 2
		
	----------------------------------------
	-- enum QWebPage::WebAction
	----------------------------------------
	
	p[#NoWebAction] = -1 -- No action is triggered
	p[#OpenLink] = 0 -- Open the current link
	p[#OpenLinkInNewWindow] = 1 -- Open the current link in a new window
	p[#OpenFrameInNewWindow] = 2 -- Replicate the current frame in a new window
	p[#DownloadLinkToDisk] = 3 -- Download the current link to the disk
	p[#CopyLinkToClipboard] = 4 -- Copy the current link to the clipboard
	p[#OpenImageInNewWindow] = 5 -- Open the highlighted image in a new window
	p[#DownloadImageToDisk] = 6 -- Download the highlighted image to the disk
	p[#CopyImageToClipboard] = 7 -- Copy the highlighted image to the clipboard
	p[#CopyImageUrlToClipboard] = 68 -- Copy the highlighted image's URL to the clipboard
	p[#Back] = 8 -- Navigate back in the history of navigated links
	p[#Forward] = 9 -- Navigate forward in the history of navigated links
	p[#Stop] = 10 -- Stop loading the current page
	p[#StopScheduledPageRefresh] = 67 -- Stop all pending page refresh/redirect requests
	p[#Reload] = 11 -- Reload the current page
	p[#ReloadAndBypassCache] = 53 -- Reload the current page, but do not use any local cache (Added in Qt 46)
	p[#Cut] = 12 -- Cut the content currently selected into the clipboard
	p[#Copy] = 13 -- Copy the content currently selected into the clipboard
	p[#Paste] = 14 -- Paste content from the clipboard
	p[#Undo] = 15 -- Undo the last editing action
	p[#Redo] = 16 -- Redo the last editing action
	p[#MoveToNextChar] = 17 -- Move the cursor to the next character
	p[#MoveToPreviousChar] = 18 -- Move the cursor to the previous character
	p[#MoveToNextWord] = 19 -- Move the cursor to the next word
	p[#MoveToPreviousWord] = 20 -- Move the cursor to the previous word
	p[#MoveToNextLine] = 21 -- Move the cursor to the next line
	p[#MoveToPreviousLine] = 22 -- Move the cursor to the previous line
	p[#MoveToStartOfLine] = 23 -- Move the cursor to the start of the line
	p[#MoveToEndOfLine] = 24 -- Move the cursor to the end of the line
	p[#MoveToStartOfBlock] = 25 -- Move the cursor to the start of the block
	p[#MoveToEndOfBlock] = 26 -- Move the cursor to the end of the block
	p[#MoveToStartOfDocument] = 27 -- Move the cursor to the start of the document
	p[#MoveToEndOfDocument] = 28 -- Move the cursor to the end of the document
	p[#SelectNextChar] = 29 -- Select to the next character
	p[#SelectPreviousChar] = 30 -- Select to the previous character
	p[#SelectNextWord] = 31 -- Select to the next word
	p[#SelectPreviousWord] = 32 -- Select to the previous word
	p[#SelectNextLine] = 33 -- Select to the next line
	p[#SelectPreviousLine] = 34 -- Select to the previous line
	p[#SelectStartOfLine] = 35 -- Select to the start of the line
	p[#SelectEndOfLine] = 36 -- Select to the end of the line
	p[#SelectStartOfBlock] = 37 -- Select to the start of the block
	p[#SelectEndOfBlock] = 38 -- Select to the end of the block
	p[#SelectStartOfDocument] = 39 -- Select to the start of the document
	p[#SelectEndOfDocument] = 40 -- Select to the end of the document
	p[#DeleteStartOfWord] = 41 -- Delete to the start of the word
	p[#DeleteEndOfWord] = 42 -- Delete to the end of the word
	p[#SetTextDirectionDefault] = 43 -- Set the text direction to the default direction
	p[#SetTextDirectionLeftToRight] = 44 -- Set the text direction to left-to-right
	p[#SetTextDirectionRightToLeft] = 45 -- Set the text direction to right-to-left
	p[#ToggleBold] = 46 -- Toggle the formatting between bold and normal weight
	p[#ToggleItalic] = 47 -- Toggle the formatting between italic and normal style
	p[#ToggleUnderline] = 48 -- Toggle underlining
	p[#InspectElement] = 49 -- Show the Web Inspector with the currently highlighted HTML element
	p[#InsertParagraphSeparator] = 50 -- Insert a new paragraph
	p[#InsertLineSeparator] = 51 -- Insert a new line
	p[#SelectAll] = 52 -- Selects all content
	p[#PasteAndMatchStyle] = 54 --Paste content from the clipboard with current style
	p[#RemoveFormat] = 55 -- Removes formatting and style
	p[#ToggleStrikethrough] = 56 -- Toggle the formatting between strikethrough and normal style
	p[#ToggleSubscript] = 57 -- Toggle the formatting between subscript and baseline
	p[#ToggleSuperscript] = 58 -- Toggle the formatting between supercript and baseline
	p[#InsertUnorderedList] = 59 -- Toggles the selection between an ordered list and a normal block
	p[#InsertOrderedList] = 60 -- Toggles the selection between an ordered list and a normal block
	p[#Indent] = 61 -- Increases the indentation of the currently selected format block by one increment
	p[#Outdent] = 62 -- Decreases the indentation of the currently selected format block by one increment
	p[#AlignCenter] = 63 -- Applies center alignment to content
	p[#AlignJustified] = 64 -- Applies full justification to content
	p[#AlignLeft] = 65 -- Applies left justification to content
	p[#AlignRight] = 66 -- Applies right justification to content
	
	me[#QWebPage] = p

	----------------------------------------
	-- enum QWebSettings::WebAttribute
	----------------------------------------
	p = [:]

	p[#AutoLoadImages] = 0
	p[#JavascriptEnabled] = 1
	p[#JavaEnabled] = 2
	p[#PluginsEnabled] = 3
	p[#PrivateBrowsingEnabled] = 4
	p[#JavascriptCanOpenWindows] = 5
	p[#JavascriptCanAccessClipboard] = 6
	p[#DeveloperExtrasEnabled] = 7
	p[#LinksIncludedInFocusChain] = 8
	p[#ZoomTextOnly] = 9
	p[#PrintElementBackgrounds] = 10
	p[#OfflineStorageDatabaseEnabled] = 11
	p[#OfflineWebApplicationCacheEnabled] = 12
	p[#LocalStorageEnabled] = 13

	extra = 0
  p[#LocalContentCanAccessRemoteUrls] = 14 + extra
  p[#DnsPrefetchEnabled] = 15 + extra
  p[#XSSAuditingEnabled] = 16 + extra
  p[#AcceleratedCompositingEnabled] = 17 + extra
  p[#SpatialNavigationEnabled] = 18 + extra
  p[#LocalContentCanAccessFileUrls] = 19 + extra
  p[#TiledBackingStoreEnabled] = 20 + extra
  p[#FrameFlatteningEnabled] = 21 + extra
  p[#SiteSpecificQuirksEnabled] = 22 + extra
  p[#JavascriptCanCloseWindows] = 23 + extra
  p[#WebGLEnabled] = 24 + extra
  p[#HyperlinkAuditingEnabled] = 25 + extra
        
	me[#QWebSettings] = p

	return me
end